set more off
clear all

global root /mnt/home/verdierv/Spatial/Spatial
cd "${root}"

timer clear
timer on 1

*Attribution of variables passed on by shell script: 

di `1'
di `2'
di `3'
di `4'
di `5'
di `6'
di `7'
*Time periods
global T=`1'
*ID number for this batch of the replications
global batchid=`3'
*Number of replications to perform for this batch
local iter=`4'
*Code for which DGP to use, 0 means no cross-sectional dependence, 1 means cluster sampling with all other auxiliary assumptions holding, 2 means cluster sampling with other auxiliary assumptions violated.
global scenario=`5'
*Parameter of interest
global rho=`6'
*Number of Clusters
global ng=`7'
*Number of clusters
global G=`2'*5/${ng}
*seed
set seed ${batchid}9${batchid}61

*mean of unobserved heterogeneity
global muc=0
*sd of transitory shocks
global sigmaepsilon=1
*sd of unobserved heterogeneity
global sigmanu=1
*Radius of spatial moving average
global radius=4

*maximum estimator id, estimator 0 is AB estimator with clustered standard errors, 1 is the unfeasible optimal estimator, 2 is the feasible cluster estimator, 3 is the feasible cluster estimator with cluster correlation set to 0, 4 is the AB estimator with the Windmeijer correction 
local numest=2

*Name of results file
global rhoname=${rho}*100
local filename results_${T}_${G}_${batchid}_${scenario}_${rhoname}_${ng}

*List of values to save from MC replication
local varnames
foreach par in rho varrho {
	forvalues est=0/`numest' {
		local varnames `varnames' `par'_`est'
	}
}

clear

tempname memhold
postfile `memhold' `varnames'  using "${root}/Results/`filename'.dta" , replace

forvalues i=1/`iter' {
		global tempname BDta_${T}_${G}_${batchid}_${scenario}_`i'_${rhoname}_${ng}
		clear
		mata: mata clear
		
		do ${root}/Code/GenerateSpatialData.do
		
		save ${root}/Temp/${tempname}.dta, replace
		
		forvalues est=0/`numest'  {
			mata: mata clear
			do ${root}/Code/`est'.do
			local rhohat`est'=${rhohat}
			local varrhohat`est'=${varrhohat}
		}
		
		local obs
		foreach par in rho varrho {
			forvalues est=0/`numest' {
				local obs `obs' (``par'hat`est'')
			}
		}
		post `memhold' `obs'
	di `i'
}

postclose `memhold'

timer off 1
timer list




