mata 

//Declare necessary functions to run non-linear first stage regression

real matrix function varcovxi(real vector par) {
	real matrix varcovxi, lowerdiag, diag
	real scalar sigmac, tauc, sigmau, tauu, b, sigma0, tscalar

	sigmac=par[1,1]
	tauc=par[2,1]
	sigmau=par[3,1]
	tauu=par[4,1]
	b=par[5,1]
	sigma0=par[6,1]
	tscalar= par[7,1]
	
	lowerdiag=(0,0,0,0\b^2*tauc*sigmac^2+tauu*sigma0^2,0,0,0\b*sigmac^2,b*tauc*sigmac^2,0,0\b*tauc*sigmac^2,1/(${ng}-1)*b*sigmac^2+(${ng}-2)/(${ng}-1)*b*tauc*sigmac^2,tauc*sigmac^2+1/tscalar*tauu*sigmau^2,0)
	
	diag=(b^2*sigmac^2+sigma0^2,0,0,0\0,1/(${ng}-1)*(b^2*sigmac^2+sigma0^2)+(${ng}-2)/(${ng}-1)*(b^2*tauc*sigmac^2+tauu*sigma0^2),0,0\0,0,sigmac^2+1/tscalar*sigmau^2,0\0,0,0,1/(${ng}-1)*(sigmac^2+1/tscalar*sigmau^2)+(${ng}-2)/(${ng}-1)*(tauc*sigmac^2+1/tscalar*tauu*sigmau^2))
	
	varcovxi=lowerdiag+diag+lowerdiag'

	return(varcovxi)
}

real matrix function Ec(real vector par) {
	external real matrix xi1, xi2, ypastsum, yl1pastsum, ypastsumothers, yl1pastsumothers
	external real scalar Tmax
	real scalar rho, sigmac, tauc, sigmau, tauu, b, sigma0, tscalar
	real matrix betat, betatxy, betatxx, beta1t, beta2t, beta3t, beta4t, xi3, xi4, parvarcov
	
	part=par'
	
	rho=part[1,1]
	muc=part[2,1]
	sigmac=part[3,1]
	tauc=part[4,1]
	sigmau=part[5,1]
	tauu=part[6,1]
	b=part[7,1]
	sigma0=part[8,1]

	ones=J(rows(xi1),1,1)

	xi3=ypastsum-rho*yl1pastsum
	xi4=ypastsumothers-rho*yl1pastsumothers

	tscalar=1

	parvarcov=(sigmac\tauc\sigmau\tauu\b\sigma0\tscalar)

	betatxy=(b*sigmac^2,b*tauc*sigmac^2,0,0)
	betatxx=varcovxi(parvarcov)
	betatxx=blockdiag(betatxx[1::2,1::2],I(2))
	betat=betatxy*qrinv(betatxx)
	
	betatxy=(b*sigmac^2,b*tauc*sigmac^2,sigmac^2,tauc*sigmac^2)
	
	for (tscalar=1;tscalar<=Tmax;tscalar++) {
		parvarcov=(sigmac\tauc\sigmau\tauu\b\sigma0\tscalar)
		betatxx=varcovxi(parvarcov)
		betat=betat\(betatxy*qrinv(betatxx))
	}

	beta1t=J(${nobs},1,1)#betat[.,1]
	beta2t=J(${nobs},1,1)#betat[.,2]
	beta3t=J(${nobs},1,1)#betat[.,3]
	beta4t=J(${nobs},1,1)#betat[.,4]

	Ec=muc*ones+(xi1-b*muc*ones):*beta1t+(xi2-b*muc*ones):*beta2t+(xi3-muc*ones):*beta3t+(xi4-muc*ones):*beta4t
	
	return(Ec)
}

real matrix function at(real scalar rho) {
	external real matrix T, ones, t
	real matrix at
	
	at=ones-(T-t):^-1*rho/(1-rho):*(ones-(rho*ones):^(T-t))
	
	return(at)
}

real matrix function bt(real scalar rho) {
	external real matrix T, ones, t
	real matrix bt
	
	bt=-ones/(1-rho)+(T-t):^-1*rho/(1-rho)^2:*(ones-(rho*ones):^(T-t))
	
	return(bt)
}

real matrix function yl1tildehat(real vector par) {
	external real matrix yl1
	real matrix EChat, yl1tildehat, at, bt
	real scalar rho, sigmau, b, sigma0
	
	rho=par[1,1]

	sigmau=par[1,5]

	b=1/(1-rho)
	sigma0=(sigmau^2/(1-rho^2))^.5

	EChat=Ec((par,(b,sigma0)))
	
	at=at(rho)
	bt=bt(rho)

	yl1tildehat=at:*yl1+bt:*EChat
	
	return(yl1tildehat)
}

real scalar function objective_function(real vector par) {
	external real matrix yl1tilde, crossdep, Vutildeinv	
	real scalar obj_function, rho, muc, sigmac, tauc, sigmau, tauu
	real matrix error, parcpred

	rho=par[1,1]
	muc=par[1,2]
	sigmac=par[1,3]
	if (crossdep==1) {
		tauc=par[1,4]
		sigmau=par[1,5]
		tauu=par[1,6]
	}
	if (crossdep==0) {
		tauc=0
		sigmau=par[1,4]
		tauu=0
	}

	parcpred=(rho,muc,sigmac,tauc,sigmau,tauu)

	error=yl1tilde-yl1tildehat(parcpred)
	
	obj_function=error'*error

	return(obj_function)

}

end

