preserve

xtset id t

gen ypastsum2=L.ypastsum
gen yl1pastsum2=L.yl1pastsum
gen ypastsumothers2=L.ypastsumothers
gen yl1pastsumothers2=L.yl1pastsumothers

drop ypastsum yl1pastsum ypastsumothers yl1pastsumothers
rename ypastsum2 ypastsum
rename yl1pastsum2 yl1pastsum
rename ypastsumothers2 ypastsumothers
rename yl1pastsumothers2 yl1pastsumothers

drop if t==${T}|t==0

local crossdep=`1'

su id if t==1
global nobs=r(N)

mata

crossdep=`crossdep'
Tmax=${T}-2

ytilde=st_data(.,"ytilde")
yl1tilde=st_data(.,"yl1tilde")
yl1=st_data(.,"yl1")

t=st_data(.,"t")

ones=J(rows(t),1,1)
T=${T}*ones

xi1=st_data(.,"xi1")
xi2=st_data(.,"xi2")

ypastsum=st_data(.,"ypastsum")	
yl1pastsum=st_data(.,"yl1pastsum")
ypastsumothers=st_data(.,"ypastsumothers")	
yl1pastsumothers=st_data(.,"yl1pastsumothers")

void objective_function_eval2(todo, x, f, g, H) {
			f = objective_function(x);
			pragma unused g; pragma unused H; //we do not calculate gradient or hessian
	}

optimization_S = optimize_init();
optimize_init_which(optimization_S,"min");
optimize_init_valueid(optimization_S,"SSR");
optimize_init_evaluator(optimization_S, &objective_function_eval2());

if (crossdep==1) {
	starting=(0.5,0.5,0.5,0,0.5,0)
}

if (crossdep==0) {
	starting=(0.5,0.5,0.5,0.5)
}

optimize_init_params(optimization_S,starting);

//stopping criteria settings
optimize_init_conv_ptol(optimization_S,0.01); 
optimize_init_conv_vtol(optimization_S,0.01);
optimize_init_conv_maxiter(optimization_S,150); 

optimize_init_technique(optimization_S,"bfgs")

rc = _optimize(optimization_S);

parhat=optimize_result_params(optimization_S)
objective_function=optimize_result_value(optimization_S)

end

su c 
local sigmac=r(sd)
su u
local sigmau=r(sd)

mata

if (crossdep==1) {
	starting=(${rho},0,`sigmac',.5,`sigmau',.5)
}

if (crossdep==0) {
	starting=(${rho},0,`sigmac',`sigmau')
}

optimize_init_params(optimization_S,starting);

rc = _optimize(optimization_S);

if (optimize_result_value(optimization_S)<objective_function) {
	parhat=optimize_result_params(optimization_S)
	objective_function=optimize_result_value(optimization_S)
}

if (crossdep==0) {
	parhat=parhat[1,1::3],(0,parhat[1,4],0)
}

st_numscalar("rhohat",parhat[1,1])

end

restore

preserve

if `crossdep'==1 {
	gen vhat=y-rhohat*L1.y
	by id: gen vhatpastsum=sum(vhat)
	egen vhattotalsum=sum(vhat), by(id)
	gen vhatfuturesum=vhattotalsum-vhatpastsum
	gen vhattilde=vhat-(1/(${T}-t))*vhatfuturesum if t<${T}
	gen uhattilde=vhattilde

	gen normeduhattilde=uhattilde/sqrt(1+1/(${T}-t)) if t<${T}
	
	egen uhattildeothers=sum(uhattilde) if t<${T}, by(cluster t)
	replace uhattildeothers=1/(ng-1)*(uhattildeothers-uhattilde) if t<${T}

	gen normeduhattildeothers=uhattildeothers/sqrt(1+1/(${T}-t)) if t<${T}

	correlate normeduhattilde normeduhattildeothers, covariance
	local tauuhat=r(cov_12)/r(Var_1)
}

restore

if `crossdep'==0 {
	local tauuhat=0
}

mata
		tauuhatmat=`tauuhat'
end

drop if t==${T}

*end



