set more off

clear

*Create Lattice
mata
	x=(1-${radius}::1+sqrt(${G})*8+${radius})
	y=(1-${radius}::1+sqrt(${G})*8+${radius})
	rowsxy=(1+sqrt(${G})*8+2*${radius})
	x=x#J(rowsxy,1,1)
	y=J(rowsxy,1,1)#y
end

local maxxy=1+sqrt(${G})*8
local rowsxy=`maxxy'+2*${radius}
local Nobs=(`rowsxy')^2
set obs `Nobs'

getmata x y

forvalues t=1/$T {
	gen epsilon`t'=rnormal()*${sigmaepsilon}
	gen u`t'=epsilon`t' if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'
}

gen nu=rnormal()*${sigmanu}
gen c=nu if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'

gen epsilon0=rnormal()*${sigmaepsilon}/sqrt(1-${rho}^2)
gen u0=epsilon0 if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'

forvalues d=1/$radius {
	forvalues xdelta=-`d'/`d' {
		forvalues ydelta=-`d'/`d' {
			if (`xdelta'!=0)|(`ydelta'!=0) {
				local distance=max(abs(`xdelta'),abs(`ydelta'))
				
				*replace u0=u0+1/`distance'/(4*(2*`distance'))*epsilon0[_n+((`rowsxy')*`xdelta')+(`ydelta')] if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'
				replace u0=u0+1/`distance'*epsilon0[_n+((`rowsxy')*`xdelta')+(`ydelta')] if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'
				
				*replace c=c+1/`distance'/(4*(2*`distance'))*nu[_n+((`rowsxy')*`xdelta')+(`ydelta')] if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'
				replace c=c+1/`distance'*nu[_n+((`rowsxy')*`xdelta')+(`ydelta')] if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'
				
				forvalues t=1/$T {
					*replace u`t'=u`t'+1/`distance'/(4*(2*`distance'))*epsilon`t'[_n+((`rowsxy')*`xdelta')+(`ydelta')] if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'
					replace u`t'=u`t'+1/`distance'*epsilon`t'[_n+((`rowsxy')*`xdelta')+(`ydelta')] if x>=1&x<=`maxxy'&y>=1&y<=`maxxy'
				}
			}	
		}
	}
}

drop if x<1|x>`maxxy'|y<1|y>`maxxy'

if $scenario ==1 {
	keep if ((floor((x-3)/4)==(x-3)/4)&(floor((y-3)/4)==(y-3)/4))|((floor((x-5)/8)==(x-5)/8)&(floor((y-5)/8)==(y-5)/8))
}

if $scenario ==2 {
	keep if (((floor((x-4)/8)==(x-4)/8)|(floor((x-6)/8)==(x-6)/8))&((floor((y-4)/8)==(y-4)/8)|(floor((y-6)/8)==(y-6)/8)))|((floor((x-5)/8)==(x-5)/8)&(floor((y-5)/8)==(y-5)/8))
}

gen cluster=sqrt(${G})*(floor((x-1)/8))+(floor((y-1)/8))+1

gen y0=c/(1-${rho})+u0

forvalues t=1/$T {
	local tm1=`t'-1
	gen y`t'=${rho}*y`tm1'+c+u`t'
}

sort cluster x y
gen obs=1
replace obs=obs[_n-1]+1 if cluster==cluster[_n-1]
gen id=_n

rename x x1
rename y x2

reshape long y u, i(cluster obs) j(t)

gen ng=${ng}
