set more off

global root /mnt/home/verdierv/Spatial/Spatial/Results

cd "${root}"

local listrho 80
local listN 25
local listT 10
local listcorr 1 2
local maxid=250
local listest 0 1 2 

foreach N in `listN' {
	foreach T in `listT' {
		foreach corr in `listcorr' {
			foreach rho in `listrho' {
				use results_`T'_`N'_1_`corr'_`rho'_5.dta, clear
				forvalues id=2/`maxid' {
					append using results_`T'_`N'_`id'_`corr'_`rho'_5.dta
				}
				save results_`T'_`N'_`corr'_`rho'.dta, replace
			}
		}
	}
}

local count=0
foreach N in `listN' {
	foreach T in `listT' {
		foreach corr in `listcorr' {
			foreach rho in `listrho' {
				global rho=`rho'/100
				use results_`T'_`N'_`corr'_`rho'.dta, clear
				foreach par in rho {
					foreach est in `listest' {
							gen se`par'_`est'=var`par'_`est'^(1/2)
							gen lb`par'_`est'=`par'_`est'-invttail(`N',0.025)*se`par'_`est'
							gen ub`par'_`est'=`par'_`est'+invttail(`N',0.025)*se`par'_`est'
							gen success`par'_`est'=0
							replace success`par'_`est'=1 if (lb`par'_`est'<${rho})&(${rho}<ub`par'_`est')
							gen fail`par'_`est'=0
							replace fail`par'_`est'=1 if (lb`par'_`est'<0)&(0<ub`par'_`est')
							gen leng`par'_`est'=ub`par'_`est'-lb`par'_`est'
							gen `par'sq_`est'=(`par'_`est'-${rho})^2
					}
				}
				foreach par in rho serho successrho rhosq failrho lengrho {
					foreach est in `listest' {
							su `par'_`est'
							local E`par'`est'`N'`T'`corr'`rho'=r(mean)
							local V`par'`est'`N'`T'`corr'`rho'=r(sd)^2
							local o`par'`est'`N'`T'`corr'`rho'=r(N)
					}
				}
				foreach par in rho {
					foreach est in `listest' {
							local count=`count'+1
							local b`par'`est'`N'`T'`corr'`rho'=`E`par'`est'`N'`T'`corr'`rho''-${rho}
							local sd`par'`est'`N'`T'`corr'`rho'=(`V`par'`est'`N'`T'`corr'`rho'')^(1/2)
							local rmse`par'`est'`N'`T'`corr'`rho'=(`E`par'sq`est'`N'`T'`corr'`rho'')^(1/2)
							local rat`par'`est'`N'`T'`corr'`rho'=`Ese`par'`est'`N'`T'`corr'`rho''/(`V`par'`est'`N'`T'`corr'`rho'')^(1/2)
							local cov`par'`est'`N'`T'`corr'`rho'=`Esuccess`par'`est'`N'`T'`corr'`rho''
							local mis`par'`est'`N'`T'`corr'`rho'=`Efail`par'`est'`N'`T'`corr'`rho''
							local leng`par'`est'`N'`T'`corr'`rho'=`Eleng`par'`est'`N'`T'`corr'`rho''
					}
				}
			}
		}
	}
}

clear

local count=`count'*8

set obs `count'

gen N=.
gen T=.
gen corr=.
gen par=""
gen est=.
gen mean=.
gen measure=""
gen rho=0.1

local row=1
foreach N in `listN' {
	foreach T in `listT' {
		foreach corr in `listcorr' {
			foreach rho in `listrho' {
				foreach par in rho { 
					foreach est in `listest' {
							foreach measure in o b sd rmse rat cov mis leng  {
								replace N=`N' in `row'
								replace T=`T' in `row'
								replace corr=`corr' in `row'
								replace par="$"+"\"+"`par'"+"$" in `row'
								replace est=`est' in `row'
								replace measure="`measure'" in `row'
								replace mean=``measure'`par'`est'`N'`T'`corr'`rho'' in `row'
								replace rho=`rho'/100 in `row'
								local row=`row'+1 
							}
					}
				}
			}
		}
	}
}

save Results.dta, replace
outsheet using Results.txt, replace
export excel using Results.xls, replace


